diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
index ea739bee2..06934a60f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
@@ -2,8 +2,13 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tool.ItemToolPickaxe;
+import net.minecraft.core.item.tool.ItemToolShears;
+import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
@@ -16,6 +21,8 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
+import java.util.Random;
+
 public class BlockLogicGrowthRubyglass extends BlockLogic implements BlockLogic.MatcherDataEquivalency.Masked {
 
 	public static final int DIRECTION_MASK = 0b0000_0111;
@@ -25,6 +32,8 @@ public class BlockLogicGrowthRubyglass extends BlockLogic implements BlockLogic.
 	public static final int STATE_BOTTOM = 0b0000_1000;
 	public static final int STATE_TOP = 0b0001_0000;
 
+	public static final int GROWTH_CHANCE = 16;
+
 	public BlockLogicGrowthRubyglass(final @NotNull Block<?> block, final @NotNull Material material) {
 		super(block, material);
 	}
@@ -69,6 +78,26 @@ public class BlockLogicGrowthRubyglass extends BlockLogic implements BlockLogic.
 		}
 	}
 
+	@Override
+	public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+		if (world.isClientSide || !isRandomTick) return;
+		if (rand.nextInt(GROWTH_CHANCE) != 0) return;
+
+		int data = world.getBlockData(tilePos);
+		if ((data & SHAPE_MASK) != STATE_BUD) return;
+
+		Direction dir = Direction.fromId(data & DIRECTION_MASK);
+
+		TilePos anchorPos = tilePos.add(dir.opposite(), new TilePos());
+		if (world.getBlockType(anchorPos) != Blocks.RUBYGLASS_NODE) return;
+
+		TilePos growthPos = tilePos.add(dir, new TilePos());
+		if (world.getBlockType(growthPos) != Blocks.AIR) return;
+
+		world.setBlockTypeDataNotify(growthPos, this.block, STATE_TOP | dir.id);
+		world.setBlockDataNotify(tilePos, STATE_BOTTOM | dir.id);
+	}
+
 	@Override
 	public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
 		TilePos anchorPos = tilePos.add(side.direction().opposite(), new TilePos());
@@ -209,11 +238,26 @@ public class BlockLogicGrowthRubyglass extends BlockLogic implements BlockLogic.
         };
 	}
 
+	@Override
+	public void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
+		final @Nullable ItemStack heldStack = player.inventory.getCurrentItem();
+		final @Nullable Item heldItem = heldStack != null ? heldStack.getItem() : null;
+
+		if (heldItem instanceof ItemToolPickaxe || heldItem instanceof ItemToolShears || (heldItem != null && heldItem.isSilkTouch())) {
+			super.onHarvest(world, player, tilePos, data, tileEntity);
+			return;
+		}
+
+		player.addStat(this.block.getStat(StatList.STAT_MINED), 1);
+		this.dropWithCause(world, EnumDropCause.IMPROPER_TOOL, tilePos, data, tileEntity, player);
+	}
+
 	@Override
 	public ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         if (dropCause == EnumDropCause.PICK_BLOCK) {
             return new ItemStack[]{this.block.getDefaultStack()};
-        } else if (dropCause == EnumDropCause.SILK_TOUCH) {
+        } else if (dropCause == EnumDropCause.SILK_TOUCH || dropCause == EnumDropCause.PROPER_TOOL
+            || dropCause == EnumDropCause.WORLD || dropCause == EnumDropCause.PISTON_CRUSH) {
             int shape = data & SHAPE_MASK;
 
             if (shape == STATE_BOTTOM) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 2ec2342a0..228e9804a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1159,8 +1159,9 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withHardness(1.5F).withOverrideColor(MaterialColor.rubyglass)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.PREVENT_MOB_SPAWNS);
     public static final @NotNull Block<?> RUBYGLASS_GROWTH = register("rubyglass.growth", "minecraft:block/rubyglass_growth", 825, block -> new BlockLogicGrowthRubyglass(block, Materials.PLANT))
-        .withSound(BlockSounds.CRYSTAL).withOverrideColor(MaterialColor.rubyglass)
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.SHEARS_DO_SILK_TOUCH);
+        .withSound(BlockSounds.CRYSTAL).withHardness(1F).withOverrideColor(MaterialColor.rubyglass)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.SHEARS_DO_SILK_TOUCH)
+        .setTicking(true);
     public static final @NotNull Block<?> RUBYGLASS_NODE = register("rubyglass.node", "minecraft:block/rubyglass_node", 826, (b) -> new BlockLogicNodeRubyglass(b))
         .withSound(BlockSounds.CRYSTAL).withHardness(3F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
@@ -1554,6 +1555,12 @@ public final class Blocks {
     public static final @NotNull Block<?> PRESSURE_PLATE_BRIMSTONE = register("pressureplate.brimstone", "minecraft:block/pressure_plate_brimstone", 1117, (b) -> new BlockLogicPressurePlate<>(b, Mob.class, Materials.STONE))
         .withSound(BlockSounds.STONE).withHardness(0.9F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final @NotNull Block<?> PRESSURE_PLATE_MARBLE = register("pressureplate.marble", "minecraft:block/pressure_plate_marble", 1118, (b) -> new BlockLogicPressurePlate<>(b, Mob.class, Materials.MARBLE))
+        .withSound(BlockSounds.STONE).withHardness(0.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final @NotNull Block<?> PRESSURE_PLATE_SLATE = register("pressureplate.slate", "minecraft:block/pressure_plate_slate", 1119, (b) -> new BlockLogicPressurePlate<>(b, Mob.class, Materials.SLATE))
+        .withSound(BlockSounds.STONE).withHardness(0.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final @NotNull Block<?> BUTTON_BASALT = register("button.basalt", "minecraft:block/button_basalt", 1120, BlockLogicButton::new)
         .withSound(BlockSounds.STONE).withHardness(0.5F)
@@ -1579,6 +1586,12 @@ public final class Blocks {
     public static final @NotNull Block<?> BUTTON_BRIMSTONE = register("button.brimstone", "minecraft:block/button_brimstone", 1127, BlockLogicButton::new)
         .withSound(BlockSounds.STONE).withHardness(0.9F)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final @NotNull Block<?> BUTTON_MARBLE = register("button.marble", "minecraft:block/button_marble", 1128, BlockLogicButton::new)
+        .withSound(BlockSounds.STONE).withHardness(0.5F)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+    public static final @NotNull Block<?> BUTTON_SLATE = register("button.slate", "minecraft:block/button_slate", 1129, BlockLogicButton::new)
+        .withSound(BlockSounds.STONE).withHardness(0.5F)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static <T extends BlockLogic> Block<T> register(String key, String namespaceId, int id, BlockLogicSupplier<T> logicSupplier) {
         Block<T> container = new Block<>(id, key, namespaceId, logicSupplier);
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index 1a2e889c2..63d7186fb 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -82,6 +82,7 @@ public class Registries extends Registry<Registry<?>> {
 
         ITEM_GROUPS.register("minecraft:stones", stackListOf(Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.PERMAFROST, Blocks.NETHERRACK, Blocks.GLOOMSTONE));
         ITEM_GROUPS.register("minecraft:cobblestones", stackListOf(Blocks.COBBLE_STONE, Blocks.COBBLE_BASALT, Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_GRANITE, Blocks.COBBLE_PERMAFROST, Blocks.COBBLE_NETHERRACK, Blocks.COBBLE_GLOOMSTONE));
+        ITEM_GROUPS.register("minecraft:mossy_cobblestones", stackListOf(Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_BASALT_MOSSY, Blocks.COBBLE_LIMESTONE_MOSSY, Blocks.COBBLE_GRANITE_MOSSY));
         ITEM_GROUPS.register("minecraft:grasses", stackListOf(Blocks.GRASS, Blocks.GRASS_RETRO));
         ITEM_GROUPS.register("minecraft:dirt", stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED));
         ITEM_GROUPS.register("minecraft:trommel_dirt", stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED, Blocks.GRASS, Blocks.GRASS_RETRO, Blocks.GRASS_SCORCHED, Blocks.PATH_DIRT, Blocks.FARMLAND_DIRT));
@@ -133,6 +134,8 @@ public class Registries extends Registry<Registry<?>> {
             buttonsList.add(Blocks.BUTTON_GLOOMSTONE.getDefaultStack());
             buttonsList.add(Blocks.BUTTON_SANDSTONE.getDefaultStack());
             buttonsList.add(Blocks.BUTTON_BRIMSTONE.getDefaultStack());
+            buttonsList.add(Blocks.BUTTON_MARBLE.getDefaultStack());
+            buttonsList.add(Blocks.BUTTON_SLATE.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_STONE.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_BASALT.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_LIMESTONE.getDefaultStack());
@@ -142,6 +145,8 @@ public class Registries extends Registry<Registry<?>> {
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_GLOOMSTONE.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_SANDSTONE.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_BRIMSTONE.getDefaultStack());
+            pressurePlatesList.add(Blocks.PRESSURE_PLATE_MARBLE.getDefaultStack());
+            pressurePlatesList.add(Blocks.PRESSURE_PLATE_SLATE.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_COBBLE_STONE.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_COBBLE_BASALT.getDefaultStack());
             pressurePlatesList.add(Blocks.PRESSURE_PLATE_COBBLE_LIMESTONE.getDefaultStack());
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
index ee8b0f514..88a17f3af 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
@@ -247,6 +247,9 @@ public final class CreativeMenuContents {
 		addBlock(list, Blocks.SLATE_POLISHED);
 		addBlock(list, Blocks.SLAB_SLATE_POLISHED);
 		list.add(new ItemStack(Items.STATUE_SLATE));
+
+		addBlock(list, Blocks.BUTTON_SLATE);
+		addBlock(list, Blocks.PRESSURE_PLATE_SLATE);
 		newPage(list);
 
 
@@ -397,6 +400,9 @@ public final class CreativeMenuContents {
 		list.add(new ItemStack(Items.STATUE_MARBLE));
 		list.add(new ItemStack(Items.STATUE_PIGMAN));
 
+		addBlock(list, Blocks.BUTTON_MARBLE);
+		addBlock(list, Blocks.PRESSURE_PLATE_MARBLE);
+
 
 		newPage(list);
 	}
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
index 87c96be42..b0ad03edd 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
@@ -737,6 +737,10 @@ tile.button.sandstone.name=Sandstone Button
 tile.button.sandstone.desc=Emits a brief redstone signal when pressed.
 tile.button.brimstone.name=Brimstone Button
 tile.button.brimstone.desc=Emits a brief redstone signal when pressed.
+tile.button.marble.name=Marble Button
+tile.button.marble.desc=Emits a brief redstone signal when pressed.
+tile.button.slate.name=Slate Button
+tile.button.slate.desc=Emits a brief redstone signal when pressed.
 
 tile.button.planks.name=Wooden Button
 tile.button.planks.desc=Emits a brief redstone signal when pressed.
@@ -797,6 +801,10 @@ tile.pressureplate.sandstone.name=Sandstone Pressure Plate
 tile.pressureplate.sandstone.desc=Emits a redstone signal when living creatures step on it.
 tile.pressureplate.brimstone.name=Brimstone Pressure Plate
 tile.pressureplate.brimstone.desc=Emits a redstone signal when living creatures step on it.
+tile.pressureplate.marble.name=Marble Pressure Plate
+tile.pressureplate.marble.desc=Emits a redstone signal when living creatures step on it.
+tile.pressureplate.slate.name=Slate Pressure Plate
+tile.pressureplate.slate.desc=Emits a redstone signal when living creatures step on it.
 
 tile.pressureplate.planks.oak.name=Wooden Pressure Plate
 tile.pressureplate.planks.oak.desc=Emits a redstone signal when anything steps on it.
diff --git a/util/datagen/build.gradle.kts b/util/datagen/build.gradle.kts
index e416c8b22..573986482 100644
--- a/util/datagen/build.gradle.kts
+++ b/util/datagen/build.gradle.kts
@@ -32,6 +32,16 @@ val runDatagen by tasks.registering(JavaExec::class) {
     args = listOf("--output", recipesDir.toString())
 }
 
+val runTrommelReport by tasks.registering(JavaExec::class) {
+    group = "bta.generator"
+    description = "Sieves stacks of input through every trommel recipe and prints their loot distribution"
+
+    outputs.upToDateWhen { false }
+
+    mainClass.set("net.minecraft.datagen.TrommelYieldReport")
+    classpath = sourceSets["main"].runtimeClasspath
+}
+
 tasks.named("jar", Jar::class) {
     duplicatesStrategy = DuplicatesStrategy.INCLUDE;
     from(sourceSets["generated"].resources)
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
index 81de6c796..45b93b3d5 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/TrommelGenerator.java
@@ -31,7 +31,7 @@ public class TrommelGenerator {
         RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
             .setInput(Blocks.MUD)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE)), 4)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.STRING), 1, 3), 2)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.STRING), 1, 3), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SLIMEBALL), 1, 4), 0.5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLOTH), 1, 2), 0.5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CHAINLINK), 1), 0.25)
@@ -46,17 +46,18 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 4), 15)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DYE,1, DyeColor.BLUE.itemMeta), 2, 6), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_REDSTONE), 2, 4), 4)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1), 0.5)
             .create("gravel");
 
         RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
             .setInput(Blocks.DIRT_SCORCHED_RICH)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1, 2), 10)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 15)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1, 4), 25)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1, 4), 25)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DYE,1, DyeColor.BLUE.itemMeta), 2, 4), 20)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLAY), 4, 8), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1, 2), 17)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 17)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1, 4), 24)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1, 4), 24)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DYE,1, DyeColor.BLUE.itemMeta), 1, 4), 17)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLAY), 4, 8), 8)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 5), 5)
             .create("rich_dirt");
 
@@ -66,6 +67,7 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLAY), 2, 5), 20)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 3), 15)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 2), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_REDSTONE), 2, 4), 4)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 0.5)
@@ -78,7 +80,7 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 2)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1), 1)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 6), 5)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 2)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 3)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 2), 15)
             .create("soulsand");
 
@@ -90,8 +92,7 @@ public class TrommelGenerator {
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 2), 10)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 5)
             .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULFUR), 1, 2), 10)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 5)
-            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 0.5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.RUBYGLASS), 1), 2.5)
             .create("brimsand");
 
         RecipeBuilder.Trommel(RecipesGenerator.CORE_NAMESPACE)
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/TrommelYieldReport.java b/util/datagen/src/main/java/net/minecraft/datagen/TrommelYieldReport.java
new file mode 100644
index 000000000..610d91241
--- /dev/null
+++ b/util/datagen/src/main/java/net/minecraft/datagen/TrommelYieldReport.java
@@ -0,0 +1,213 @@
+package net.minecraft.datagen;
+
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Random;
+
+/**
+ * Sieves a number of stacks of input through every trommel recipe declared by {@link TrommelGenerator}
+ * and prints the resulting loot distribution.
+ */
+public class TrommelYieldReport {
+    private static final int STACK_SIZE = 64;
+    private static final int STACKS_SIEVED = 27;
+
+    private final int stacksSieved;
+    private final int passes;
+    private final long seed;
+
+    public TrommelYieldReport(int stacksSieved, long seed) {
+        this.stacksSieved = stacksSieved;
+        this.passes = stacksSieved * STACK_SIZE;
+        this.seed = seed;
+    }
+
+    public static void main(String @NotNull [] args) {
+        int stacksSieved = STACKS_SIEVED;
+        long seed = new Random().nextLong();
+
+        int pointer = 0;
+        while (pointer < args.length) {
+            switch (args[pointer]) {
+                case "--stacks": {
+                    stacksSieved = Integer.parseInt(args[pointer + 1]);
+                    pointer++;
+                    pointer++;
+                    break;
+                }
+                case "--seed": {
+                    seed = Long.parseLong(args[pointer + 1]);
+                    pointer++;
+                    pointer++;
+                    break;
+                }
+                default:
+                    pointer++;
+            }
+        }
+
+        Blocks.init();
+        Items.init();
+        new Registries();
+
+        TrommelGenerator.generate();
+
+        new TrommelYieldReport(stacksSieved, seed).run();
+    }
+
+    public void run() {
+        RecipeGroup<RecipeEntryTrommel> trommelRecipes = Registries.RECIPES.TROMMEL;
+        check(!trommelRecipes.getAllRecipes().isEmpty(), "No trommel recipes were generated!");
+
+        System.out.printf("Sieving %s stacks through every trommel recipe with seed %s%n", this.stacksSieved, this.seed);
+
+        Random random = new Random(this.seed);
+
+        for (RecipeEntryTrommel recipe : trommelRecipes) {
+            sieve(trommelRecipes.getKey(recipe), recipe, random);
+        }
+    }
+
+    private void sieve(String recipeId, RecipeEntryTrommel recipe, Random random) {
+        WeightedRandomBag<WeightedRandomLootObject> bag = recipe.getOutput();
+
+        List<Result> results = new ArrayList<>();
+        double totalWeight = 0;
+
+        for (WeightedRandomBag<WeightedRandomLootObject>.Entry entry : bag.getEntriesWithWeights()) {
+
+            results.add(new Result(entry.getObject(), entry.getWeight()));
+            totalWeight += entry.getWeight();
+
+        }
+
+        check(!results.isEmpty(), "Trommel recipe '" + recipeId + "' has no entries!");
+
+        for (int pass = 0; pass < this.passes; pass++) {
+
+            WeightedRandomLootObject loot = bag.getRandom(random);
+            check(loot != null, "Trommel recipe '" + recipeId + "' rolled no loot object!");
+
+            ItemStack stack = loot.getItemStack(random);
+            check(stack != null, "Trommel recipe '" + recipeId + "' rolled a null stack!");
+
+            Result result = find(results, stack);
+            check(result != null, "Trommel recipe '" + recipeId + "' rolled undeclared output " + describe(stack) + "!");
+
+            result.record(recipeId, stack);
+        }
+
+        print(recipeId, recipe, results, totalWeight);
+    }
+
+    private Result find(List<Result> results, ItemStack stack) {
+        for (Result result : results) {
+            if (result.matches(stack)) return result;
+        }
+
+        return null;
+    }
+
+    private void print(String recipeId, RecipeEntryTrommel recipe, List<Result> results, double totalWeight) {
+        System.out.println();
+
+        System.out.printf("=== trommel/%s - input %s - %s items sieved (%s stacks) ===%n",
+            recipeId, describe(recipe.getInput()), this.passes, this.stacksSieved);
+
+        int totalRolls = 0;
+        int totalItems = 0;
+
+        for (Result result : results) {
+            printRow(result.name(),
+                String.format("weight %6.2f (%6.2f%%)", result.weight, (result.weight / totalWeight) * 100),
+                result.rolls,
+                result.items);
+            totalRolls += result.rolls;
+            totalItems += result.items;
+        }
+
+        printRow("TOTAL", "", totalRolls, totalItems);
+
+        check(totalRolls == this.passes, "Trommel recipe '" + recipeId + "' did not sieve every input item!");
+    }
+
+    private void printRow(String name, String weight, int rolls, int items) {
+        System.out.printf("\t%-30s %-22s rolled %4sx (%6.2f%%) - %5s items (%5.2f stacks)%n",
+            name, weight, rolls, (rolls / (float) this.passes) * 100, items, items / (float) STACK_SIZE);
+    }
+
+    private static void check(boolean condition, String message) {
+        if (!condition) throw new IllegalStateException(message);
+    }
+
+    private static String describe(RecipeSymbol input) {
+        if (input.getStack() != null) return describe(input.getStack());
+        return input.getItemGroup();
+    }
+
+    private static String describe(ItemStack stack) {
+        Item item = stack.getItem();
+        String name = item.namespaceID.toString();
+        return stack.getMetadata() != 0 ? name + "@" + stack.getMetadata() : name;
+    }
+
+    private static class Result {
+
+        private final WeightedRandomLootObject loot;
+        private final double weight;
+        private int rolls;
+        private int items;
+
+        public Result(WeightedRandomLootObject loot, double weight) {
+            this.loot = loot;
+            this.weight = weight;
+        }
+
+        public boolean matches(ItemStack stack) {
+
+            ItemStack declared = this.loot.getDefinedItemStack();
+
+            if (declared == null || declared.itemID != stack.itemID) return false;
+
+            if (this.loot.isRandomMeta()) {
+                return stack.getMetadata() >= this.loot.getMinMeta() && stack.getMetadata() <= this.loot.getMaxMeta();
+            }
+
+            return declared.getMetadata() == stack.getMetadata();
+        }
+
+        public void record(String recipeId, ItemStack stack) {
+
+            if (this.loot.isRandomYield()) {
+                check(stack.stackSize >= this.loot.getMinYield() && stack.stackSize <= this.loot.getMaxYield(),
+                    "Trommel recipe '" + recipeId + "' rolled " + stack.stackSize + " " + name() + ", outside of its declared yield of "
+                        + this.loot.getMinYield() + "-" + this.loot.getMaxYield() + "!");
+            }
+
+            else {
+                check(stack.stackSize == this.loot.getFixedYield(),
+                    "Trommel recipe '" + recipeId + "' rolled the wrong amount of " + name() + "!");
+            }
+
+            this.rolls++;
+            this.items += stack.stackSize;
+        }
+
+        public String name() {
+            ItemStack declared = this.loot.getDefinedItemStack();
+            return declared == null ? "NULL" : describe(declared);
+        }
+    }
+}
